"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseFeatureFlags = exports.getFeatureFlags = void 0;
const cspell_lib_1 = require("cspell-lib");
function getFeatureFlags() {
    return (0, cspell_lib_1.getSystemFeatureFlags)();
}
exports.getFeatureFlags = getFeatureFlags;
function parseFeatureFlags(flags, featureFlags = getFeatureFlags()) {
    if (!flags)
        return featureFlags;
    const flagsKvP = flags.map((f) => f.split(':', 2));
    for (const flag of flagsKvP) {
        const [name, value] = flag;
        try {
            featureFlags.setFlag(name, value);
        }
        catch (e) {
            console.warn(`Unknown flag: "${name}"`);
        }
    }
    return featureFlags;
}
exports.parseFeatureFlags = parseFeatureFlags;
//# sourceMappingURL=featureFlags.js.map